local dospawn = GetModConfigData("worldgen")
local owntomes = GetModConfigData("basegame")

Assets = {
	Asset("ATLAS","images/guide/ash.xml"),
	Asset("IMAGE","images/guide/ash.tex"),
	Asset("ATLAS","images/guide/blood.xml"),
	Asset("IMAGE","images/guide/blood.tex"),
	Asset("ATLAS","images/guide/mech.xml"),
	Asset("IMAGE","images/guide/mech.tex"),
	Asset("ATLAS","images/guide/rog.xml"),
	Asset("IMAGE","images/guide/rog.tex"),
	Asset("ATLAS","images/guide/runes.xml"),
	Asset("IMAGE","images/guide/runes.tex"),
	Asset("ATLAS","images/guide/web.xml"),
	Asset("IMAGE","images/guide/web.tex"),
	--giants
	Asset("ATLAS","images/guide/giants/king.xml"),
	Asset("IMAGE","images/guide/giants/king.tex"),
	Asset("ATLAS","images/guide/giants/queen.xml"),
	Asset("IMAGE","images/guide/giants/queen.tex"),
	Asset("ATLAS","images/guide/giants/deerclops.xml"),
	Asset("IMAGE","images/guide/giants/deerclops.tex"),
	Asset("ATLAS","images/guide/giants/goose.xml"),
	Asset("IMAGE","images/guide/giants/goose.tex"),
	Asset("ATLAS","images/guide/giants/dragonfly.xml"),
	Asset("IMAGE","images/guide/giants/dragonfly.tex"),
	Asset("ATLAS","images/guide/giants/bearger.xml"),
	Asset("IMAGE","images/guide/giants/bearger.tex"),
	--caves
	Asset("ATLAS","images/guide/cave/lobster.xml"),
	Asset("IMAGE","images/guide/cave/lobster.tex"),
	Asset("ATLAS","images/guide/cave/flower.xml"),
	Asset("IMAGE","images/guide/cave/flower.tex"),
	--things
	Asset("ATLAS","images/guide/things/ring.xml"),
	Asset("IMAGE","images/guide/things/ring.tex"),
	Asset("ATLAS","images/guide/things/box.xml"),
	Asset("IMAGE","images/guide/things/box.tex"),
	Asset("ATLAS","images/guide/things/crank.xml"),
	Asset("IMAGE","images/guide/things/crank.tex"),
	Asset("ATLAS","images/guide/things/potato.xml"),
	Asset("IMAGE","images/guide/things/potato.tex"),
	Asset("ATLAS","images/guide/things/wood.xml"),
	Asset("IMAGE","images/guide/things/wood.tex"),
	--cane kiting
	Asset("ATLAS","images/guide/canekite.xml"),
	Asset("IMAGE","images/guide/canekite.tex"),
}

PrefabFiles = {
	"modguide"
}

GLOBAL.TomesToMake = {}

--I wish this constructor would be more presentable...1
GLOBAL.MakeTome = function(name, pages, anim, customanim, spawn, spawnchance, toc, locktochapter, swfloatable)
	local data = {prefab=name,pages=pages,anim=anim,custombuild=customanim,spawn=spawn,chance=spawnchance,toc=toc,chapters=locktochapter,float=swfloatable}
	
	table.insert(GLOBAL.TomesToMake, data)
end

local STRINGS = GLOBAL.STRINGS
local require = GLOBAL.require
--local TheWorld = upvalues are no good
--local TheClock = GLOBAL.GetClock()
local MakeTome = GLOBAL.MakeTome

if owntomes then

------EXAMPLE------
local giants_pack = require "tok_giants" --I'm importing a file because it's cleaner
MakeTome("tok_giants",giants_pack[1],"tome_low","tokbooks","FAR",nil,giants_pack[2])
--name, pages, anim, customanim, spawn, spawnchance, toc, locktochapter

STRINGS.NAMES.TOK_GIANTS = "Giants - Magnified Forces" --setting the name as usual
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOK_GIANTS = "It's a tome of knowledge!"
-------------------
local caves_pack = require "tok_caves"
MakeTome("tok_caves",caves_pack,"tome_low","tokbooks","FAR",.9)

STRINGS.NAMES.TOK_CAVES = "Spelunker's Manual"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOK_CAVES = "It's a tome of knowledge!"
-------------------
local things_pack = require "tok_things"
MakeTome("tok_things",things_pack[1],"tome_low","tokbooks","FAR",nil,things_pack[2])

STRINGS.NAMES.TOK_THINGS = "The Thing about the Things"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOK_THINGS = "It's a tome of knowledge!"
-------------------
local cook_pack = require "tok_cook"
MakeTome("tok_cook",cook_pack[1],"tome_low","tokbooks","FAR",.7,cook_pack[2])

STRINGS.NAMES.TOK_COOK = "Steve Steward's Cooking"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOK_COOK = "It's a tome of knowledge!"
-------------------
local cane_pack = require "tok_cane"
MakeTome("tok_cane",cane_pack,"tome_pro","tokbooks","FAR",.3)

STRINGS.NAMES.TOK_CANE = "Cane Kiting"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOK_CANE = "It's a tome of pro skills!"
-------------------
local shrooms_pack = require "tok_shrooms"
MakeTome("tok_shrooms",shrooms_pack,"tome_pro","tokbooks","FAR",.4)

STRINGS.NAMES.TOK_SHROOMS = "Mycology"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TOK_SHROOMS = "It's a tome of pro skills!"
-------------------

end

local function getrandomposition() --modified from purple staff
    local ground = GLOBAL.GetWorld()
    local targets = {}
    for i,node in ipairs(ground.topology.nodes) do
		local x = node.x + math.random(-32,32) --be "near" a road
		local z = node.y + math.random(-32,32) --but not always "on" a road
        local tile = ground.Map:GetTileAtPoint(x,0,z)
		local other = GLOBAL.TheSim:FindEntities(x,0,z, 7, "guide")
        if tile and tile ~= GLOBAL.GROUND.IMPASSABLE and tile < GLOBAL.GROUND.UNDERGROUND --TODO is this SW-friendly?
		and #other == 0 then
            table.insert(targets, {x = x, z = z})
        end
    end
    if #targets > 0 then
        local pos = targets[math.random(#targets)]
        return GLOBAL.Vector3(pos.x, 0, pos.z)
    end
end

local function PostLoad(player)
	if GLOBAL.GetClock().numcycles == 0 and GLOBAL.GetClock():GetNormTime() == 0
	and GLOBAL.GetWorld().topology.level_type == "survival" and dospawn then
		local pos = player:GetPosition()
		
		for _,data in pairs(GLOBAL.TomesToMake) do
			if not data.chance or data.chance >= 0 then
				if dospawn == "DEFAULT" and data.spawn and data.spawn == "FAR"
				or dospawn == "FAR" then
					if (not data.chance or math.random() < data.chance) then
						local offset = getrandomposition()
						
						if not offset then --retreat to near
							offset = GLOBAL.FindWalkableOffset(pos, math.random()*2*GLOBAL.PI,20,12)
							if offset then
								offset = offset + pos
							end
						end
						
						if offset then
							local book = GLOBAL.SpawnPrefab(data.prefab)
							book.Transform:SetPosition(offset.x,offset.y,offset.z)
						end
					end				
				elseif dospawn == "DEFAULT" and data.spawn --need not check further as it stands
				or dospawn == "NEAR" then
					if (not data.chance or math.random() < data.chance) then
						local offset = GLOBAL.FindWalkableOffset(pos, math.random()*2*GLOBAL.PI,20,12)
						
						if offset then
							offset = pos + offset
							local book = GLOBAL.SpawnPrefab(data.prefab)
							book.Transform:SetPosition(offset.x,offset.y,offset.z)
						end
					end
				end
			end
		end
	end
end

AddSimPostInit(PostLoad)