local Widget = require "widgets/widget"
local Text = require "widgets/text"
local Image = require "widgets/image"
local Button = require "widgets/button"
local ImageButton = require "widgets/imagebutton"
--local Menu = require "widgets/menu"
local Screen = require "widgets/screen"
--local PopupScreen = require "screens/bigpopupdialog" --I should just use that thing actually... oh screw it

local TheScreen = Class(Screen, function(self,inst)
	Screen._ctor(self, "modguide_screen")
	
	self.book = inst
	
	self.active = true
	SetPause(true,"pause")
	
	--darken everything behind the dialog
	self.black = self:AddChild(Image("images/global.xml", "square.tex"))
	self.black:SetVRegPoint(ANCHOR_MIDDLE)
	self.black:SetHRegPoint(ANCHOR_MIDDLE)
	self.black:SetVAnchor(ANCHOR_MIDDLE)
	self.black:SetHAnchor(ANCHOR_MIDDLE)
	self.black:SetScaleMode(SCALEMODE_FILLSCREEN)
	self.black:SetTint(0,0,0,.5)	
	
	--a root for easier screen-poppening (I think)
	self.proot = self:AddChild(Widget("ROOT"))
	self.proot:SetVAnchor(ANCHOR_MIDDLE)
	self.proot:SetHAnchor(ANCHOR_MIDDLE)
	self.proot:SetPosition(0,0,0)
	self.proot:SetScaleMode(SCALEMODE_PROPORTIONAL)

	--display the background
	self.bg = self.proot:AddChild(Image("images/globalpanels.xml", "panel.tex")) --use paper image instead?
	self.bg:SetVRegPoint(ANCHOR_MIDDLE)
	self.bg:SetHRegPoint(ANCHOR_MIDDLE)
	self.bg:SetScale(2,1.75,1)
	
	--page header and text (and image)
	self.image = self.proot:AddChild(Image())
	self.txt_head = self.proot:AddChild(Text(TITLEFONT, 50))
	self.txt_head:SetPosition(0,270,0)
	self.txt_page = self.proot:AddChild(Text(BODYTEXTFONT, 36))
	
	--[[the "next" button (increases page count by one)
	self.bnext = self.proot:AddChild(ImageButton())
	self.bnext:SetPosition(-100, -300, 0)
	self.bnext:SetText("Next Page")
	self.bnext:SetOnClick(function() self:NextPage() end)]]
	
	--two arrow buttons to scroll through
	self.goleft = self.proot:AddChild(ImageButton(nil,"next_arrow.tex","next_arrow_over.tex","next_arrow.tex"))
	self.goleft:SetPosition(-140, -320, 0)
	self.goleft:SetScale(-.8,.8,.8)
	self.goleft:SetOnClick(function() self.i = self.i - 1 self:UpdatePage() end)
	
	self.goright = self.proot:AddChild(ImageButton(nil,"next_arrow.tex","next_arrow_over.tex","next_arrow.tex"))
	self.goright:SetPosition(140, -320, 0)
	self.goright:SetScale(.8,.8,.8)
	self.goright:SetOnClick(function() self.i = self.i + 1 self:UpdatePage() end)
	
	--the resume button
	self.bresume = self.proot:AddChild(ImageButton())
	self.bresume:SetPosition(0, -325, 0)
	self.bresume:SetText("Close")
	--self.bresume:SetFont(BUTTONFONT)
	self.bresume:SetOnClick(function()
		TheFrontEnd:PopScreen(self)
		if not self.was_paused then
			SetPause(false)
		end
		GetWorld():PushEvent("continuefrompause")
	end)
	
	
	--initiate pages
	self.pages = self.book.pages or {}
	
	--initiate table of content
	if self.book.toc then
		self.toc = self.book.toc
		self.locktochapters = self.book.chapters
		
		--self.toc_buttons = {} --or create a sub-root?
		self.toc_buttonroot = self.proot:AddChild(Widget("ROOT"))
		local counter = 1
		for y = 2,-2,-1 do --for every row do
			for x = -2,2 do --for every column do
				--if counter <= #self.toc then
					local button = self.toc_buttonroot:AddChild(ImageButton())
					--table.insert(self.toc_buttons, self:AddChild(ImageButton()))
					self.toc_buttonroot["b".. counter] = button
					--self.toc_buttons[#self.toc_buttons]:SetPosition(90 * x,50 * y,0)
					button:SetPosition(155 * x,90 * y -15,0)
					
					local _OnGainFocus = button.OnGainFocus
					local _OnLoseFocus = button.OnLoseFocus

					button.OnGainFocus = function()
						self:ShowHoverhint( button )
						_OnGainFocus( button )
					end
					button.OnLoseFocus = function()
						self:HideHoverhint( button )
						_OnLoseFocus( button )
					end
					
					counter = counter + 1
				--end
			end
		end
		
		if not self.book.currentpage then
		self:IndexPage(1)
		end
	end
	
	if not self.toc or self.book.currentpage then
		self:NextPage(self.book.currentpage or 1)
	end

	
	
	if self.toc then
		self.hovertext = self.proot:AddChild(Text(TALKINGFONT, 28, ""))
		self.hovertext:SetClickable(false)
		self.hovertext:SetRegionSize(800, 40)
		--self.hovertext:EnableWordWrap(true)
		--self.hovertext:SetPosition(0, -40)
		
		self.hovertext_bg = self.proot:AddChild(Image("images/ui.xml", "buttonblk.tex"))
		--self.hovertext_bg:SetPosition(params.offset_x or 0, params.offset_y or 26)
		local w, h = self.hovertext:GetRegionSize()
		self.hovertext_bg:SetTint(1,1,1,.8)
		self.hovertext_bg:SetSize(w * .7, h*1.7)
		self.hovertext_bg:SetClickable(false)
		
		self.hovertext_bg:MoveToFront()
		self.hovertext:MoveToFront() --The order matters
		self.hovertext_bg:Hide()
		self.hovertext:Hide()
	end
	
	TheInputProxy:SetCursorVisible(true)
	self.default_focus = self.bresume
end)

function TheScreen:UpdatePage(...)
	if self.toc_buttonroot and self.toc_buttonroot:IsVisible() then
		self:IndexPage(...)
	else
		self:NextPage(...)
	end
end

function TheScreen:IndexPage(i)
	self.i = i or self.i
	self.book.currentpage = nil
	
	--clear the last page
	self.image:Hide()
	self.txt_head:SetString("Table of Content")
	self.txt_page:SetString("")
	
	--update the button menu
	self.toc_buttonroot:Show()
	
	for n = 1,math.min(25) do
		local m = n + (self.i-1)*25 --how many we have to skip (in toc table only)
		local button = self.toc_buttonroot["b".. n]
		if m <= #self.toc then
			--set the name
			button:SetText(self.toc[m].name)
			button.hoverhint = self.toc[m].hover
			--check whether it meets enabling criteria
			if self.toc[m].condition and not self.toc[m].condition(self.book) then
				button:Disable()
			else
				button:Enable()
				
				--set up cb
				button:SetOnClick(function() --should we set it up only once and change variables?
					--find to that page
					if self.toc[m].goto then
						for j = 1,#self.pages do
							if self.pages[j].head == self.toc[m].goto then
								--go to that page (and stop looking)
								self:NextPage(j)
								break
							end
						end
					end
					
					--execute the custom callback
					if self.toc[m].cb then
						print("Tome executes custom callback for",self.book.prefab,self.toc[m].name)
						self.toc[m].cb(self.book,self)
					end
				end)
				
			end
		else
			button:SetText("")
			button.hoverhint = nil
			button:Disable()
		end
	end
	
	self.bresume:SetText("Close")
	self.bresume:SetOnClick(function() --make it close the book
		TheFrontEnd:PopScreen(self)
		if not self.was_paused then
			SetPause(false)
		end
		GetWorld():PushEvent("continuefrompause")
	end)
	
	--update arrows (to prevent shooting past the target)
	self.goright:Enable()
	self.goleft:Enable()
	 if self.i <= 1 then
		self.i = 1
		self.goleft:Disable()
	end
	if #self.toc <= 25 * self.i then
		self.i = math.ceil(#self.toc/25)
		self.goright:Disable()
	end
end

function TheScreen:NextPage(i)
	self.i = i or self.i -- +1
	self.book.currentpage = self.i
	
	if not self.pages[self.i] then --Oh no!
		if #self.pages == 0 or self.i == 1 then --prevent loops
			TheFrontEnd:PopScreen(self) 
			SetPause(false)
			GetWorld():PushEvent("continuefrompause")
		end
		
		TheScreen:NextPage(1) --try to recover
	end
	
	if self.toc_buttonroot then
		self.toc_buttonroot:Hide() --hide the index buttons
		
		self.bresume:SetText("Index")
		self.bresume:SetOnClick(function() --return to index at will
			self:IndexPage(1)
		end)
	end
	
	if self.pages[self.i].head then --use header space if there's no header
		self.txt_page:SetPosition(0,-15,0)
		self.image:SetPosition(0,-15,0)
	else
		self.txt_page:SetPosition(0,10,0)
		self.image:SetPosition(0,10,0)
	end
	
	self.txt_head:SetString(self.pages[self.i].head or "")
	self.txt_page:SetString(self.pages[self.i].page or "")
	
	if self.pages[self.i].atlas and self.pages[self.i].tex then
		self.image:SetTexture( self.pages[self.i].atlas, self.pages[self.i].tex )
		self.image:Show()
	else
		self.image:Hide()
	end
	
	--update arrows (to prevent shooting past the target)
	self.goright:Enable()
	self.goleft:Enable()
	if self.i <= 1 then
		self.i = 1
		self.goleft:Disable()
	elseif self.locktochapters and self.pages[self.i].head and
	(not self.pages[self.i -1].head or self.pages[self.i].head ~= self.pages[self.i -1].head) then
		self.goleft:Disable()
	end
	if self.i >= #self.pages then
		self.i = #self.pages
		self.goright:Disable()
	elseif self.locktochapters and self.pages[self.i +1].head and (not self.pages[self.i].head
	or self.pages[self.i].head ~= self.pages[self.i +1].head) then
		self.goright:Disable()
	end
end

function TheScreen:HideHoverhint(button)
	if not self.hovertext then return end
		
	if button then
		--if button.hoverhint then
		local text = button.hoverhint
		if type(button.hoverhint) == "function" then
			text = button.hoverhint(self.book, button:IsEnabled())
		end
		if text and text ~= "" then
			if self.hovertext:GetString() == text then
				print("Hiding")
				self.hovertext_bg:Hide()
				self.hovertext:Hide()
			end
		end
		--end
	end
end

function TheScreen:ShowHoverhint(button)
	if not self.hovertext then return end
	
	if button then
		--if button.hoverhint then
		local text = button.hoverhint
		if type(button.hoverhint) == "function" then
			text = button.hoverhint(self.book, button:IsEnabled())
		end
		if text and text ~= "" then
			print("Showing", text)
			self.hovertext_bg:Show()
			self.hovertext:Show()
			
			local pos = button:GetLocalPosition()
			self.hovertext:SetPosition(pos.x ,pos.y - 80)
			self.hovertext_bg:SetPosition(pos.x ,pos.y - 80)
			
			self.hovertext:SetString(text)
			return true
		end
		--end
	end
end

function TheScreen:OnControl(control, down) --this is for ESCAPEing the screen :P
	if TheScreen._base.OnControl(self,control, down) then return true end

	if (control == CONTROL_PAUSE or control == CONTROL_CANCEL) and not down then	
		self.active = false
		TheFrontEnd:PopScreen() 
		SetPause(false)
		GetWorld():PushEvent("continuefrompause")
		return true
	end

end

function TheScreen:OnUpdate(dt)
	if self.active then
		SetPause(true)
	end
end

--[[
function TheScreen:OnBecomeActive()
	TheScreen._base.OnBecomeActive(self)
	TheFrontEnd:HideTopFade()
end
]]

return TheScreen